EntityImpl (Xerces2 Implementation)
Date: 2018-10-17

org.apache.xerces.dom

## Class EntityImpl

- java.lang.Object
- - org.apache.xerces.dom.NodeImpl
  - - org.apache.xerces.dom.ChildNode
    - - org.apache.xerces.dom.ParentNode
      - - org.apache.xerces.dom.EntityImpl

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Cloneable, org.w3c.dom.Entity, org.w3c.dom.events.EventTarget, org.w3c.dom.Node, org.w3c.dom.NodeList
  Direct Known Subclasses:
    DeferredEntityImpl

      public class EntityImpl
      extends ParentNode
      implements org.w3c.dom.Entity

  Entity nodes hold the reference data for an XML Entity -- either parsed or unparsed. The nodeName (inherited from Node) will contain the name (if any) of the Entity. Its data will be contained in the Entity's children, in exactly the structure which an EntityReference to this name will present within the document's body.

  Note that this object models the actual entity, _not_ the entity declaration or the entity reference.

  An XML processor may choose to completely expand entities before the structure model is passed to the DOM; in this case, there will be no EntityReferences in the DOM tree.

  Quoting the 10/01 DOM Proposal,

  > "The DOM Level 1 does not support editing Entity nodes; if a user wants to make changes to the contents of an Entity, every related EntityReference node has to be replaced in the structure model by a clone of the Entity's contents, and then the desired changes must be made to each of those clones instead. All the descendants of an Entity node are readonly."

  I'm interpreting this as: It is the parser's responsibilty to call the non-DOM operation setReadOnly(true,true) after it constructs the Entity. Since the DOM explicitly decided not to deal with this, _any_ answer will involve a non-DOM operation, and this is the simplest solution.
  Since:
    PR-DOM-Level-1-19980818.
  Version:
    $Id: EntityImpl.java 447266 2006-09-18 05:57:49Z mrglavas $
  Author:
    Elena Litani, IBM
  See Also:
    Serialized Form

  # INTERNAL:

    Usage of this class is not supported. It may be altered or removed at any time.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected java.lang.String` | `baseURI` base uri
    `protected java.lang.String` | `encoding` Encoding
    `protected java.lang.String` | `inputEncoding` Input Encoding
    `protected java.lang.String` | `name` Entity name.
    `protected java.lang.String` | `notationName` Notation name.
    `protected java.lang.String` | `publicId` Public identifier.
    `protected java.lang.String` | `systemId` System identifier.
    `protected java.lang.String` | `version` Version

    - ### Fields inherited from class org.apache.xerces.dom.ParentNode

      `firstChild, fNodeListCache, ownerDocument`

    - ### Fields inherited from class org.apache.xerces.dom.ChildNode

      `nextSibling, previousSibling`

    - ### Fields inherited from class org.apache.xerces.dom.NodeImpl

      `DOCUMENT_POSITION_CONTAINS, DOCUMENT_POSITION_DISCONNECTED, DOCUMENT_POSITION_FOLLOWING, DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC, DOCUMENT_POSITION_IS_CONTAINED, DOCUMENT_POSITION_PRECEDING, ELEMENT_DEFINITION_NODE, FIRSTCHILD, flags, HASSTRING, ID, IGNORABLEWS, NORMALIZED, OWNED, ownerNode, READONLY, SPECIFIED, SYNCCHILDREN, SYNCDATA, TREE_POSITION_ANCESTOR, TREE_POSITION_DESCENDANT, TREE_POSITION_DISCONNECTED, TREE_POSITION_EQUIVALENT, TREE_POSITION_FOLLOWING, TREE_POSITION_PRECEDING, TREE_POSITION_SAME_NODE`

    - ### Fields inherited from interface org.w3c.dom.Node

      `ATTRIBUTE_NODE, CDATA_SECTION_NODE, COMMENT_NODE, DOCUMENT_FRAGMENT_NODE, DOCUMENT_NODE, DOCUMENT_POSITION_CONTAINED_BY, DOCUMENT_POSITION_CONTAINS, DOCUMENT_POSITION_DISCONNECTED, DOCUMENT_POSITION_FOLLOWING, DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC, DOCUMENT_POSITION_PRECEDING, DOCUMENT_TYPE_NODE, ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, NOTATION_NODE, PROCESSING_INSTRUCTION_NODE, TEXT_NODE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `EntityImpl(CoreDocumentImpl ownerDoc, java.lang.String name)` Factory constructor.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `org.w3c.dom.Node` | `cloneNode(boolean deep)` Clone node.
    `java.lang.String` | `getBaseURI()` Returns the absolute base URI of this node or null if the implementation wasn't able to obtain an absolute URI.
    `java.lang.String` | `getInputEncoding()` An attribute specifying the encoding used for this entity at the tiome of parsing, when it is an external parsed entity.
    `java.lang.String` | `getNodeName()` Returns the entity name
    `short` | `getNodeType()` A short integer indicating what type of node this is.
    `java.lang.String` | `getNotationName()` Unparsed entities -- which contain non-XML data -- have a "notation name" which tells applications how to deal with them.
    `java.lang.String` | `getPublicId()` The public identifier associated with the entity.
    `java.lang.String` | `getSystemId()` The system identifier associated with the entity.
    `java.lang.String` | `getXmlEncoding()` DOM Level 3 WD - experimental the encoding of this entity, when it is an external parsed entity.
    `java.lang.String` | `getXmlVersion()` DOM Level 3 WD - experimental the version number of this entity, when it is an external parsed entity.
    `void` | `setBaseURI(java.lang.String uri)` NON-DOM: set base uri
    `void` | `setInputEncoding(java.lang.String inputEncoding)` NON-DOM, used to set the input encoding.
    `void` | `setNotationName(java.lang.String name)` DOM Level 2: Unparsed entities -- which contain non-XML data -- have a "notation name" which tells applications how to deal with them.
    `void` | `setPublicId(java.lang.String id)` DOM Level 2: The public identifier associated with the entity.
    `void` | `setSystemId(java.lang.String id)` DOM Level 2: The system identifier associated with the entity.
    `void` | `setXmlEncoding(java.lang.String value)` NON-DOM encoding - An attribute specifying, as part of the text declaration, the encoding of this entity, when it is an external parsed entity.
    `void` | `setXmlVersion(java.lang.String value)` NON-DOM version - An attribute specifying, as part of the text declaration, the version number of this entity, when it is an external parsed entity.

    - ### Methods inherited from class org.apache.xerces.dom.ParentNode

      `getChildNodes, getChildNodesUnoptimized, getFirstChild, getLastChild, getLength, getOwnerDocument, getTextContent, hasChildNodes, insertBefore, isEqualNode, item, normalize, removeChild, replaceChild, setOwnerDocument, setReadOnly, setTextContent, synchronizeChildren`

    - ### Methods inherited from class org.apache.xerces.dom.ChildNode

      `getNextSibling, getParentNode, getPreviousSibling`

    - ### Methods inherited from class org.apache.xerces.dom.NodeImpl

      `addEventListener, appendChild, changed, changes, compareDocumentPosition, compareTreePosition, dispatchEvent, getAttributes, getContainer, getFeature, getLocalName, getNamespaceURI, getNodeNumber, getNodeValue, getPrefix, getReadOnly, getUserData, getUserData, getUserDataRecord, hasAttributes, isDefaultNamespace, isSameNode, isSupported, lookupNamespaceURI, lookupPrefix, needsSyncChildren, removeEventListener, setNodeValue, setPrefix, setUserData, setUserData, synchronizeData, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.w3c.dom.Node

      `appendChild, compareDocumentPosition, getAttributes, getChildNodes, getFeature, getFirstChild, getLastChild, getLocalName, getNamespaceURI, getNextSibling, getNodeValue, getOwnerDocument, getParentNode, getPrefix, getPreviousSibling, getTextContent, getUserData, hasAttributes, hasChildNodes, insertBefore, isDefaultNamespace, isEqualNode, isSameNode, isSupported, lookupNamespaceURI, lookupPrefix, normalize, removeChild, replaceChild, setNodeValue, setPrefix, setTextContent, setUserData`

- - ### Field Detail

    - #### name

          protected java.lang.String name

      Entity name.

    - #### publicId

          protected java.lang.String publicId

      Public identifier.

    - #### systemId

          protected java.lang.String systemId

      System identifier.

    - #### encoding

          protected java.lang.String encoding

      Encoding

    - #### inputEncoding

          protected java.lang.String inputEncoding

      Input Encoding

    - #### version

          protected java.lang.String version

      Version

    - #### notationName

          protected java.lang.String notationName

      Notation name.

    - #### baseURI

          protected java.lang.String baseURI

      base uri

  - ### Constructor Detail

    - #### EntityImpl

          public EntityImpl(CoreDocumentImpl ownerDoc,
                            java.lang.String name)

      Factory constructor.

  - ### Method Detail

    - #### getNodeType

          public short getNodeType()

      A short integer indicating what type of node this is. The named constants for this value are defined in the org.w3c.dom.Node interface.
      Specified by:
        `getNodeType` in interface `org.w3c.dom.Node`
      Specified by:
        `getNodeType` in class `NodeImpl`

    - #### getNodeName

          public java.lang.String getNodeName()

      Returns the entity name
      Specified by:
        `getNodeName` in interface `org.w3c.dom.Node`
      Specified by:
        `getNodeName` in class `NodeImpl`

    - #### cloneNode

          public org.w3c.dom.Node cloneNode(boolean deep)

      Clone node.
      Specified by:
        `cloneNode` in interface `org.w3c.dom.Node`
      Overrides:
        `cloneNode` in class `ParentNode`
      Parameters:
        `deep` - If `true`, recursively clone the subtree under the specified node; if `false`, clone only the node itself (and its attributes, if it is an `Element`).
      Returns:
        The duplicate node.
      See Also:
        `

        Example: Cloning a Text node will copy both the node and the text it contains.

        Example: Cloning something that has children -- Element or Attr, for example -- will _not_ clone those children unless a "deep clone" has been requested. A shallow clone of an Attr node will yield an empty Attr of the same name.

        NOTE: Clones will always be read/write, even if the node being cloned is read-only, to permit applications using only the DOM API to obtain editable copies of locked portions of the tree.

        `

    - #### getPublicId

          public java.lang.String getPublicId()

      The public identifier associated with the entity. If not specified, this will be null.
      Specified by:
        `getPublicId` in interface `org.w3c.dom.Entity`

    - #### getSystemId

          public java.lang.String getSystemId()

      The system identifier associated with the entity. If not specified, this will be null.
      Specified by:
        `getSystemId` in interface `org.w3c.dom.Entity`

    - #### getXmlVersion

          public java.lang.String getXmlVersion()

      DOM Level 3 WD - experimental the version number of this entity, when it is an external parsed entity.
      Specified by:
        `getXmlVersion` in interface `org.w3c.dom.Entity`

    - #### getXmlEncoding

          public java.lang.String getXmlEncoding()

      DOM Level 3 WD - experimental the encoding of this entity, when it is an external parsed entity.
      Specified by:
        `getXmlEncoding` in interface `org.w3c.dom.Entity`

    - #### getNotationName

          public java.lang.String getNotationName()

      Unparsed entities -- which contain non-XML data -- have a "notation name" which tells applications how to deal with them. Parsed entities, which are in XML format, don't need this and set it to null.
      Specified by:
        `getNotationName` in interface `org.w3c.dom.Entity`

    - #### setPublicId

          public void setPublicId(java.lang.String id)

      DOM Level 2: The public identifier associated with the entity. If not specified, this will be null.

    - #### setXmlEncoding

          public void setXmlEncoding(java.lang.String value)

      NON-DOM encoding - An attribute specifying, as part of the text declaration, the encoding of this entity, when it is an external parsed entity. This is null otherwise

    - #### getInputEncoding

          public java.lang.String getInputEncoding()

      An attribute specifying the encoding used for this entity at the tiome of parsing, when it is an external parsed entity. This is `null` if it an entity from the internal subset or if it is not known..
      Specified by:
        `getInputEncoding` in interface `org.w3c.dom.Entity`
      Since:
        DOM Level 3

    - #### setInputEncoding

          public void setInputEncoding(java.lang.String inputEncoding)

      NON-DOM, used to set the input encoding.

    - #### setXmlVersion

          public void setXmlVersion(java.lang.String value)

      NON-DOM version - An attribute specifying, as part of the text declaration, the version number of this entity, when it is an external parsed entity. This is null otherwise

    - #### setSystemId

          public void setSystemId(java.lang.String id)

      DOM Level 2: The system identifier associated with the entity. If not specified, this will be null.

    - #### setNotationName

          public void setNotationName(java.lang.String name)

      DOM Level 2: Unparsed entities -- which contain non-XML data -- have a "notation name" which tells applications how to deal with them. Parsed entities, which are in XML format, don't need this and set it to null.

    - #### getBaseURI

          public java.lang.String getBaseURI()

      Returns the absolute base URI of this node or null if the implementation wasn't able to obtain an absolute URI. Note: If the URI is malformed, a null is returned.
      Specified by:
        `getBaseURI` in interface `org.w3c.dom.Node`
      Overrides:
        `getBaseURI` in class `NodeImpl`
      Returns:
        The absolute base URI of this node or null.
      Since:
        DOM Level 3

    - #### setBaseURI

          public void setBaseURI(java.lang.String uri)

      NON-DOM: set base uri

Copyright © 1999-2010 The Apache Software Foundation. All Rights Reserved.